<div [formGroup]="form">
  <!-- <label [attr.for]="question.key">{{question.label}}</label> -->

  <div [ngSwitch]="question.controlType">
    <input class="form-control" *ngSwitchCase="'textbox'" [formControlName]="question.key" placeholder="Search..."
      [id]="question.key" [type]="question.type" [pattern]="question.pattern" />

    <select class="form-control" [id]="question.key" *ngSwitchCase="'dropdown'" [formControlName]="question.key">
      <option *ngFor="let opt of question.options" [value]="opt.key">{{
        opt.value
      }}</option>
    </select>
  </div>
  <div class="errorMessage" *ngIf="!isValid && form.controls[question.key].errors?.required">
    {{ question.label }} is required
  </div>
  <div class="errorMessage" *ngIf="!isValid && form.controls[question.key].errors?.pattern">
    {{ question.label }} is invalid
  </div>
</div>